package ru.dbotthepony.mc.otm.client.screen.panels.button

import com.mojang.blaze3d.vertex.PoseStack
import net.minecraft.client.gui.screens.Screen
import ru.dbotthepony.mc.otm.client.playGuiClickSound
import ru.dbotthepony.mc.otm.client.render.AbstractMatterySprite
import ru.dbotthepony.mc.otm.client.screen.panels.EditablePanel
import ru.dbotthepony.mc.otm.core.TextComponent
import java.util.function.IntConsumer

@Suppress("PropertyName")
abstract class RectangleButtonPanel<out S : Screen>(
	screen: S,
	parent: EditablePanel<*>?,
	x: Float = 0f,
	y: Float = 0f,
	width: Float,
	height: Float,
	var onPress: IntConsumer? = null,
) : AbstractButtonPanel<S>(screen, parent, x, y, width, height) {
	abstract val PRESSED: AbstractMatterySprite
	abstract val HOVERED: AbstractMatterySprite
	abstract val IDLE: AbstractMatterySprite
	abstract val DISABLED: AbstractMatterySprite

	override fun onClick(mouseButton: Int) {
		onPress?.accept(mouseButton)
	}

	protected fun renderSquareButton(stack: PoseStack, mouseX: Float, mouseY: Float, partialTick: Float) {
		if (isDisabled) {
			DISABLED.render(stack, 0f, 0f, width, height)
		} else if (isPressed) {
			PRESSED.render(stack, 0f, 0f, width, height)
		} else if (isHovered) {
			HOVERED.render(stack, 0f, 0f, width, height)
		} else {
			IDLE.render(stack, 0f, 0f, width, height)
		}
	}

	override fun innerRender(stack: PoseStack, mouseX: Float, mouseY: Float, partialTick: Float) {
		renderSquareButton(stack, mouseX, mouseY, partialTick)
	}
}
