package ru.dbotthepony.mc.otm.menu.matter

import net.minecraft.world.SimpleContainer
import net.minecraft.world.entity.player.Inventory
import net.minecraft.world.item.ItemStack
import ru.dbotthepony.mc.otm.block.entity.matter.MatterRecyclerBlockEntity
import ru.dbotthepony.mc.otm.item.MatterDustItem
import ru.dbotthepony.mc.otm.menu.MatteryPoweredMenu
import ru.dbotthepony.mc.otm.menu.MatterySlot
import ru.dbotthepony.mc.otm.menu.widget.LevelGaugeWidget
import ru.dbotthepony.mc.otm.menu.widget.ProgressGaugeWidget
import ru.dbotthepony.mc.otm.registry.MMenus

class MatterRecyclerMenu @JvmOverloads constructor(
	containerID: Int,
	inventory: Inventory,
	tile: MatterRecyclerBlockEntity? = null
) : MatteryPoweredMenu(MMenus.MATTER_RECYCLER, containerID, inventory, tile) {
	val input: MatterySlot
	val progress: ProgressGaugeWidget
	val matter = LevelGaugeWidget(this, tile?.matter)

	init {
		val container = tile?.container ?: SimpleContainer(1)

		input = object : MatterySlot(container, 0) {
			override fun mayPlace(itemStack: ItemStack): Boolean {
				return itemStack.item is MatterDustItem && (itemStack.item as MatterDustItem).getMatterValue(itemStack) != null
			}
		}

		if (tile == null) {
			progress = ProgressGaugeWidget(this)
		} else {
			progress = ProgressGaugeWidget(this, tile::workProgress, tile::isUnableToProcess)
		}

		addStorageSlot(input)
		addInventorySlots()
	}
}
